--- old/usr/src/uts/common/fs/zfs/dsl_dataset.c	2016-04-06 14:26:56.785720153 -0400
+++ new/usr/src/uts/common/fs/zfs/dsl_dataset.c	2016-04-06 14:26:56.789924574 -0400
@@ -270,6 +270,16 @@
 }
 
 static void
+dsl_dataset_evict_prep(void *dbu)
+{
+	dsl_dataset_t *ds = dbu;
+
+	ASSERT(ds->ds_owner == NULL);
+
+	unique_remove(ds->ds_fsid_guid);
+}
+
+static void
 dsl_dataset_evict(void *dbu)
 {
 	dsl_dataset_t *ds = dbu;
@@ -278,8 +288,6 @@
 
 	ds->ds_dbuf = NULL;
 
-	unique_remove(ds->ds_fsid_guid);
-
 	if (ds->ds_objset != NULL)
 		dmu_objset_evict(ds->ds_objset);
 
@@ -512,7 +520,8 @@
 			ds->ds_reserved = ds->ds_quota = 0;
 		}
 
-		dmu_buf_init_user(&ds->ds_dbu, dsl_dataset_evict, &ds->ds_dbuf);
+		dmu_buf_init_user(&ds->ds_dbu, dsl_dataset_evict_prep,
+		    dsl_dataset_evict, &ds->ds_dbuf);
 		if (err == 0)
 			winner = dmu_buf_set_user_ie(dbuf, &ds->ds_dbu);
 
